// Copyright (c) 2025 Tigera, Inc. All rights reserved.

// Code generated by client-gen. DO NOT EDIT.

package v3

import (
	context "context"

	projectcalicov3 "github.com/projectcalico/api/pkg/apis/projectcalico/v3"
	scheme "github.com/projectcalico/api/pkg/client/clientset_generated/clientset/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	gentype "k8s.io/client-go/gentype"
)

// IPAMHandlesGetter has a method to return a IPAMHandleInterface.
// A group's client should implement this interface.
type IPAMHandlesGetter interface {
	IPAMHandles(namespace string) IPAMHandleInterface
}

// IPAMHandleInterface has methods to work with IPAMHandle resources.
type IPAMHandleInterface interface {
	Create(ctx context.Context, iPAMHandle *projectcalicov3.IPAMHandle, opts v1.CreateOptions) (*projectcalicov3.IPAMHandle, error)
	Update(ctx context.Context, iPAMHandle *projectcalicov3.IPAMHandle, opts v1.UpdateOptions) (*projectcalicov3.IPAMHandle, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*projectcalicov3.IPAMHandle, error)
	List(ctx context.Context, opts v1.ListOptions) (*projectcalicov3.IPAMHandleList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *projectcalicov3.IPAMHandle, err error)
	IPAMHandleExpansion
}

// iPAMHandles implements IPAMHandleInterface
type iPAMHandles struct {
	*gentype.ClientWithList[*projectcalicov3.IPAMHandle, *projectcalicov3.IPAMHandleList]
}

// newIPAMHandles returns a IPAMHandles
func newIPAMHandles(c *ProjectcalicoV3Client, namespace string) *iPAMHandles {
	return &iPAMHandles{
		gentype.NewClientWithList[*projectcalicov3.IPAMHandle, *projectcalicov3.IPAMHandleList](
			"ipamhandles",
			c.RESTClient(),
			scheme.ParameterCodec,
			namespace,
			func() *projectcalicov3.IPAMHandle { return &projectcalicov3.IPAMHandle{} },
			func() *projectcalicov3.IPAMHandleList { return &projectcalicov3.IPAMHandleList{} },
		),
	}
}
